'Compilable Example:
#Compile Exe "gbofficetimer.exe"
#Dim All

#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

#Include "Win32API.inc"
#Include "GDIPlus_Simple.inc"
#Resource "gbofficetimer.pbr"

Type CustomColors
   c(15) As Long
End Type

%Countup = 1   : %CountDown = 2   : %Clock = 3
%TextOnly = 1  : %Image = 2       : %Gradient = 3     : %Animation = 4
%Matrix = 1    : %Stereogram = 2  : %FallingSand = 3
%ColorBW = 1   : %ColorYB = 2     : %ColorGG = 3      : %ColorCustom = 4

$Ver = "v1.0"

%Timer_Main      = 400

%IDC_Main        = 500

%IDM_Sep         = 600
%IDM_OnTop       = 602
%IDM_Start       = 603
%IDM_Reset       = 604
%IDM_CountDown   = 605
%IDM_CountUp     = 606
%IDM_Clock       = 607
%IDM_Colors      = 608
%IDM_Fonts       = 609
%IDM_Alarm       = 610
%IDM_Minutes     = 611
%IDM_DisplayTime = 612

%IDM_Minutes01        = 620
%IDM_Minutes05        = 621
%IDM_Minutes10        = 622
%IDM_MinutesCustom    = 623
%IDM_MinutesTimeOfDay = 624

%IDM_AutoRun     = 640
%IDM_RunNow      = 641
%IDM_SelectApp   = 642
%IDM_RunOnAlarm  = 643

%IDM_Help        = 650
%IDM_About       = 651
%IDM_Exit        = 652
%IDM_AutoExit    = 653
%IDM_ShowSettings= 654
%IDM_DefaultSize = 655

%IDM_Sound            = 660
%IDM_Continuous       = 661
%IDM_Visual           = 662
%IDM_DisplayAlarmText = 663
%IDM_Warning5         = 664
%IDM_Warning1         = 665
%IDM_Negative         = 666
%IDM_AlarmText        = 667
%IDM_SelectAlarm      = 668
%IDM_TestAlarm        = 669
%IDM_SelectWarning    = 670
%IDM_AlarmOn          = 671
%IDM_TestWarning      = 680

%IDM_SelectMainFont      = 690
%IDM_SelectMainClockFont = 691
%IDM_AutoSizeMainFont    = 693

%IDM_SelectImageFolder= 703
%IDM_SelectTextFile   = 704
%IDM_Speed0           = 705
%IDM_Speed5           = 706
%IDM_Speed10          = 707
%IDM_Speed30          = 708

%IDM_MainFG           = 710
%IDM_MainBG           = 711
%IDM_ColorBW          = 714
%IDM_ColorYB          = 715
%IDM_ColorGG          = 716
%IDM_ColorCustom      = 717


%IDM_Height0          = 720
%IDM_Height50         = 721
%IDM_Height100        = 722
%IDM_Height200        = 723

%IDM_AllowSelectTA    = 730
%IDM_SelectMainImage  = 731
%IDM_SelectRandomImage= 732
%IDM_ShowOffStatus    = 733
%IDM_ShowTAValues     = 734
%IDM_ShowNextImage    = 735
%IDM_ShowCFNRect      = 736
%IDM_RestoreOnalarm   = 737
%IDM_Minimize         = 738
%IDM_RemoveImage      = 739

%IDM_TextOnly         = 750
%IDM_Image            = 751
%IDM_Matrix           = 753
%IDM_Stereogram       = 754
%IDM_FallingSand      = 755
%IDM_Animation        = 756
%IDM_Gradient         = 757
%IDM_GradientColorLeft  = 758
%IDM_GradientCOlorRight = 759


Global hDlg, hContext, hAutoRun, hColors, hFonts, hAlarm, hMinutes, hDC As Dword
Global hMain, hSlideShow, hFontMain, hFontMainClock As Dword

'settings
Global TimerMax, TimerValue, TimerOn, MainMode, ShowCFNRect As Long
Global OnTop, DisplayTime, RunMinimized, PreventContextMenu As Long
Global AlarmSound, AlarmContinuous, AlarmVisual, AlarmText, AlarmOn, OldProc As Long
Global CountDown, CountUp, AutoSizeMainFont, ShowOffStatus As Long
Global RunOnAlarm, DisplayProgress, CenterOnAlarm, DisplayMode As Long
Global AutoExit, SlideShowOn, SlideShowInterval, ColorsMode, RestoreOnAlarm As Long
Global AlarmWarning5, AlarmWarning1, AllowNegative, AutoRunApp, FixedPitch As Long
Global AlarmMessage, AlarmSoundFile, WarningSoundFile, MainText, CFN As String
Global MainFontName, MainClockFontName, AlarmApp, CustomTime, TimeOfDay As String
Global CustomColorList As CustomColors
Global MainCustomFG, MainCustomBG, MainFG, MainBG, SlideShow, AnimationMode As Long
Global MainFontSize, MainFontAttr, AllowSelectTA, DrawRectInWork As Long
Global MainClockFontSize, MainClockFontAttr, CFNIndex As Long
Global R, R2, ROI, ROIData() As Rect
Global CFNList(), CFNListFile As String
Global RatioXY As Single, GradientColorLeft, GradientColorRight As Long

Function PBMain() As Long
   Dialog New Pixels, 0, "Test Code",300,300,200,200, %WS_Popup Or %WS_ThickFrame To hDlg
   Dialog Set Icon hDlg, "ringer"
   DragAcceptFiles hDlg, %True
   Control Add Graphic, hDlg, %IDC_Main, "", 0,0,100, 100  ', %SS_Notify
   Control Handle hDlg, %IDC_Main To hMain
   Graphic Attach hDlg, %IDC_Main, ReDraw
   Graphic Get DC To hDC
   CreateContextMenu
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h,x,y As Long, pt As Point, temp$
   Local  pRect        As RECT Pointer
   Local  DialogWidth, DialogHeight As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Randomize Timer
         BuildAcceleratorTable
         CreateSubFolders
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Main), %GWL_WndProc, CodePtr(NewMainProc))  'subclass
         Settings_INI "get"
         If IsFalse(IsFile(CFNListFile)) Then CreateCFNListFile
         LoadCFNList
         Font New MainFontName, MainFontSize, MainFontAttr To hFontMain
         Font New MainClockFontName, MainClockFontSize, MainClockFontAttr To hFontMainClock
         SetMenus
         SetColors
         GetROIFromROIData             'get ROI and adjust to current dialog size
         If TimerOn Then StartTimer
         SetOnTop
      Case %WM_Timer
          Select Case Cb.WParam
              Case %Timer_Main
                  Select Case MainMode
                      Case %CountUp
                          Incr TimerValue
                          If SlideShowInterval And (TimerValue Mod SlideShowInterval = 0) Then ShowNextImage(1)
                          If TimerOn Then DrawROIContent
                          If AlarmOn Then
                              If AlarmWarning5 And (TimerValue = TimerMax - 300) Then PlayWarning
                              If AlarmWarning1 And (TimerValue = TimerMax - 60) Then PlayWarning
                              If TimerValue = TimerMax Then
                                  If RestoreOnAlarm Then Dialog Show State hDlg, %SW_Restore
                                  SoundAlarm
                                  If AllowNegative = 0 Then
                                      TimerOn = 0
                                      StartTimer
                                  End If
                              End If
                          End If
                      Case %CountDown
                          Decr TimerValue
                          If SlideShowInterval And (TimerValue Mod SlideShowInterval = 0) Then ShowNextImage(1)
                          If TimerOn Then DrawROIContent
                          If AlarmOn Then
                              If AlarmWarning5 And (TimerValue = 300) Then PlayWarning
                              If AlarmWarning1 And (TimerValue = 60) Then PlayWarning
                              If TimerValue = 0 Then
                                  If RestoreOnAlarm Then Dialog Show State hDlg, %SW_Restore
                                  SoundAlarm
                                  If AllowNegative = 0 Then
                                      TimerOn = 0
                                      StartTimer
                                  End If
                              End If
                          End If
                      Case %Clock
                  End Select
          End Select

      Case %WM_Destroy
         Settings_INI "save"
         WriteCFNData
         KillTimer Cb.Hndl, %Timer_Main

      Case %WM_Size
         ResizeWindows

      Case %WM_Sizing
         pRect = Cb.LParam
         DialogWidth  = (@pRect.nRight - @pRect.nLeft)
         DialogHeight = (@pRect.nBottom - @pRect.nTop)
         Select Case Cb.WParam
           Case %WMSZ_TopLeft
             @pRect.nTop = @pRect.nBottom - (DialogWidth / RatioXY)
             Function = %TRUE
           Case %WMSZ_Top, %WMSZ_Bottom, %WMSZ_TopRight
             @pRect.nRight = @pRect.nLeft + (DialogHeight * RatioXY)
             Function = %TRUE
           Case %WMSZ_Left, %WMSZ_Right, %WMSZ_BottomLeft, %WMSZ_BottomRight
             @pRect.nBottom = @pRect.nTop + (DialogWidth / RatioXY)
             Function = %TRUE
         End Select

      Case %WM_DropFiles
          Select Case Right$(LCase$(GetDroppedFilename(Cb.WParam)), 4)
              Case ".bmp",".jpg",".gif",".png"
                  temp$ = GetDroppedFileName(Cb.WParam)
                  DragFinish Cb.WParam
                  LoadImageFile temp$
          End Select

      Case %WM_ContextMenu
         If PreventContextMenu = 0 Then
             x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
             TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, Cb.Hndl, ByVal 0
         Else
             PreventContextMenu = 0
         End If
      Case %WM_LButtonDown
         Dialog Get Size hDlg To w,h
         GetCursorPos pt            'screen position
         ScreenToClient hDlg, pt    'overlay position
         If Cb.WParam = %MK_LBUTTON Then SendMessage (hDlg, %WM_NCLButtonDown, %HTCaption, ByVal %Null)  ' force drag
      Case %WM_LButtonDblClk
          'start/stop timer
          TimerOn = TimerOn Xor 1
          If TimerOn = 1 Then StartTimer Else StopTimer
          SetMenus                   'change text
          DrawROIContent
      Case %WM_RButtonDown
          If (TimerOn=0) And (DisplayMode= %Image) And AllowSelectTA Then R.nLeft   = Lo(Word, Cb.LParam) : R.nTop  = Hi(Word, Cb.LParam)
      Case %WM_MouseMove
          If (TimerOn=0) And (DisplayMode=%Image) Then
              If AllowSelectTA Then
                  R.nRight  = Lo(Word, Cb.LParam) : R.nBottom = Hi(Word, Cb.LParam)
                  If Cb.WParam And %MK_RBUTTON And IsFalse(R.nRight=R2.nRight And R.nBottom=R2.nBottom) Then
                     SetROIElements                               'ROI = R, with elements reordered to match API requirements
                     If DrawRectInWork Then DrawFocusRectangle 1  'erase old R2 if draw-in-work, draw ROI
                     DrawRectInWork = 1                           'set draw-in-work (must be here ... after DrawFocusRectangle)
                     PreventContextMenu = 1                       'disable context menu
                     R2 = ROI                                     'set R2 (old focus rect) to ROI
                  End If
             End If
          End If
      Case %WM_RButtonUp
          If DrawRectInWork Then         'has moved and draw a Rect
              If BigChange Then StoreROI Else GetROIFromROIData  'save or restore (not allow little change)
              DrawFocusRectangle 0       'erase old, do not draw new
              DrawROIContent
              DrawRectInWork = 0
          End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Start
                TimerOn = TimerOn Xor 1
                If TimerOn = 1 Then
                   StartTimer
                   Menu Set Text hContext, ByCmd %IDM_Start, "Pause"
                Else
                   StopTimer
                   Menu Set Text hContext, ByCmd %IDM_Start, "Start/Continue"
                End If
                DrawROIContent
            Case %IDM_Reset
                If TimerOn Then
                   TimerOn = 0 : StopTimer    'stop
                   TimerValue = TimerMax      'reset the value
                   TimerOn = 1 : StartTimer   'restart the timer
                Else
                   TimerValue = TimerMax
                End If
                DrawROIContent

            'main display
            Case %IDM_TextOnly
                DisplayMode = %TextOnly : CFNIndex = -1 : CFN = "TextOnly"
                GetROIFromROIData       : SetMenus      : DrawROIContent
            Case %IDM_Image
                DisplayMode = %Image    : CFNIndex = 0  : CFN = CFNList(CFNIndex)
                GetROIFromROIData       : SetMenus      : DrawROIContent
            Case %IDM_Gradient
                DisplayMode = %Gradient : CFNIndex = -1 : CFN = "Gradient"
                GetROIFromROIData       : SetMenus      : DrawROIContent
            Case %IDM_Animation
                DisplayMode = %Animation
                ROI.nLeft = 0 : ROI.nTop = 0 : ROI.nRight = 400 : ROI.nBottom = 200
                SetMenus
                DrawROIContent

            Case %IDM_Matrix       : AnimationMode = %Matrix       : SetMenus  : DrawROIContent
            Case %IDM_Stereogram   : AnimationMode = %Stereogram   : SetMenus  : DrawROIContent
            Case %IDM_FallingSand  : AnimationMode = %FallingSand  : SetMenus  : DrawROIContent

            Case %IDM_DisplayTime
                DisplayTime = DisplayTime Xor 1
                SetMenus
                Dialog Post Cb.Hndl, %WM_Timer, %Timer_Main, 0     'force an initial %WM_TIMER "event"
            Case %IDM_ShowOffStatus      : ShowOffStatus = ShowOffStatus Xor 1  : DrawROIContent : SetMenus
            Case %IDM_ShowCFNRect        : ShowCFNRect = ShowCFNRect Xor 1      : DrawROIContent : SetMenus
            Case %IDM_SelectMainImage    : SelectMainImage                      : DrawROIContent : SetMenus
            Case %IDM_SelectRandomImage  : SelectRandomImage                    : DrawROIContent : SetMenus
            Case %IDM_RemoveImage        : RemoveImage                          : DrawROIContent : SetMenus

            'timer (minutes)
            Case %IDM_Minutes01        :  TimerMax  = 60                 : SetMenus  : DrawROIContent
            Case %IDM_Minutes05        :  TimerMax  = 300                : SetMenus  : DrawROIContent
            Case %IDM_Minutes10        :  TimerMax =  600                : SetMenus  : DrawROIContent
            Case %IDM_MinutesCustom    :  TimerMax = EnterCustomMinutes  : SetMenus  : DrawROIContent
            Case %IDM_MinutesTimeOfDay :  TimerMax = SetTimeOfDayMinutes : SetMenus  : DrawROIContent

            'colors
            Case %IDM_ColorBW            :  ColorsMode = %colorbw     : SetColors : SetMenus
            Case %IDM_ColorYB            :  ColorsMode = %coloryb     : SetColors : SetMenus
            Case %IDM_ColorGG            :  ColorsMode = %colorgg     : SetColors : SetMenus
            Case %IDM_ColorCustom        :  ColorsMode = %colorcustom : SetColors : SetMenus
            Case %IDM_MainFG             :  MainCustomFG = SelectColor(MainCustomFG) : SetColors : SetMenus
            Case %IDM_MainBG             :  MainCustomBG = SelectColor(MainCustomBG) : SetColors : SetMenus
            Case %IDM_GradientColorLeft  :  GradientColorLeft = SelectColor(GradientColorLeft) : SetColors :  DrawROIContent
            Case %IDM_GradientColorRight :  GradientColorRight = SelectColor(GradientColorRight) : SetColors : DrawROIContent

            'fonts
            Case %IDM_SelectMainFont       :  SelectMainFont                            : SetMenus
            Case %IDM_SelectMainClockFont  :  SelectMainClockFont                       : SetMenus
            Case %IDM_AutoSizeMainFont     :  AutoSizeMainFont = AutoSizeMainFont Xor 1 : SetMenus

            'alarm
            Case %IDM_AlarmOn              :  AlarmOn = AlarmOn Xor 1                  : SetMenus
            Case %IDM_Sound                :  AlarmSound = AlarmSound Xor 1            : SetMenus
            Case %IDM_Visual               :  AlarmVisual = AlarmVisual Xor 1          : SetMenus
            Case %IDM_DisplayAlarmText     :  AlarmText = AlarmText Xor 1              : SetMenus
            Case %IDM_Warning5             :  AlarmWarning5 = AlarmWarning5 Xor 1      : SetMenus
            Case %IDM_Warning1             :  AlarmWarning1 = AlarmWarning1 Xor 1      : SetMenus
            Case %IDM_CountDown   :  MainMode = %CountDown        : SetMenus
            Case %IDM_CountUp     :  MainMode = %CountUp          : SetMenus
            Case %IDM_Clock       :  MainMode = %Clock            : SetMenus
            Case %IDM_AutoExit    :  AutoExit = AutoExit Xor 1    : SetMenus
            Case %IDM_Negative             :  AllowNegative = AllowNegative Xor 1      : SetMenus
            Case %IDM_RestoreOnalarm       :  RestoreOnAlarm = RestoreOnAlarm Xor 1    : SetMenus
            Case %IDM_Continuous           :  AlarmContinuous = AlarmContinuous Xor 1  : SetMenus
            Case %IDM_AlarmText            :  GetAlarmMessage                          : SetMenus
            Case %IDM_SelectAlarm          :  SelectAlarmSound                         : SetMenus
            Case %IDM_TestAlarm            :  TestAlarmSound                           : SetMenus
            Case %IDM_SelectWarning        :  SelectWarningSound                       : SetMenus
            Case %IDM_TestWarning          :  PlayWarning                              : SetMenus

            'slideshow
            Case %IDM_Speed0             :  SlideShowInterval = 0                      : SetMenus
            Case %IDM_Speed5             :  SlideShowInterval = 5                      : SetMenus
            Case %IDM_Speed10            :  SlideShowInterval = 10                     : SetMenus
            Case %IDM_Speed30            :  SlideShowInterval = 30                     : SetMenus

            'autorun application
            Case %IDM_AutoRun     :  AutoRunApp = AutoRunApp Xor 1                     : SetMenus
            Case %IDM_RunNow      :  RunApplicationNow                                 : SetMenus
            Case %IDM_SelectApp   :  SelectApplication                                 : SetMenus
            Case %IDM_RunOnAlarm  :  RunOnAlarm = RunOnAlarm Xor 1                     : SetMenus

            Case %IDM_OnTop                :  OnTop = OnTop Xor 1 : SetOnTop                    : SetMenus
            Case %IDM_AllowSelectTA      : AllowSelectTA = AllowSelectTA Xor 1  : DrawROIContent : SetMenus

            'help
            Case %IDM_Minimize      :  Dialog Show State hDlg, %SW_Minimize
            Case %IDM_Help          :  OpenWebPage
            Case %IDM_About         :  OpenAboutDialog
            Case %IDM_ShowSettings  :  ShowSettings
            Case %IDM_Exit          :  Dialog End hDlg
            Case %IDM_DefaultSize   :  Dialog Set Size hDlg, 400, 200 : ResizeWIndows : DrawROIContent

            'accelerator tables
            Case %IDM_ShowTAValues       : ShowTAValues
            Case %IDM_ShowNextImage      : ShowNextImage(1)      : DrawROIContent
            Case %IDM_Gradient           : Gradient
         End Select
   End Select
End Function

Sub Settings_INI(Task$)
   Local i,x,y As Long
   Local xResult, yResult, tempz, INIFileName As AsciiZ*%Max_Path

   'defines INI file name
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      GetPrivateProfileString "All", "Left", "300", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "400", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "200", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      GetPrivateProfileString "All", "AlarmMessage", "Time is up!", tempz, %Max_Path, INIFileName                          : AlarmMessage = tempz
      GetPrivateProfileString "All", "AlarmSoundFile", Exe.Path$ + "support\alarm.wav", tempz, %Max_Path, INIFileName        : AlarmSoundFile = tempz
      GetPrivateProfileString "All", "WarningSoundFile", Exe.Path$ + "support\warning.wav", tempz, %Max_Path, INIFileName    : WarningSoundFile = tempz
      GetPrivateProfileString "All", "CFN", "", tempz, %Max_Path, INIFileName                                              : CFN = tempz
      GetPrivateProfileString "All", "MainFontName", "Courier New", tempz, %Max_Path, INIFileName                          : MainFontName = tempz
      GetPrivateProfileString "All", "MainClockFontName", "Courier New", tempz, %Max_Path, INIFileName                     : MainClockFontName = tempz
      GetPrivateProfileString "All", "CustomTime", "2:00", tempz, %Max_Path, INIFileName                                   : CustomTime = tempz
      GetPrivateProfileString "All", "TimeOfDay", "17:00", tempz, %Max_Path, INIFileName                                   : TimeOfDay = tempz
      GetPrivateProfileString "All", "CFNListFile", Exe.Path$ + "support\cfnlist.txt", tempz, %Max_Path, INIFileName       : CFNListFile = tempz
      GetPrivateProfileString "All", "MainText", "1:00", tempz, %Max_Path, INIFileName                                     : MainText = tempz

      'get value for numeric variable
      GetPrivateProfileString "All", "CFNIndex", "0", tempz, %Max_Path, INIFileName              : CFNIndex = Val(tempz)
      GetPrivateProfileString "All", "TimerMax", "60", tempz, %Max_Path, INIFileName             : TimerMax = Val(tempz)
      GetPrivateProfileString "All", "TimerValue", "60", tempz, %Max_Path, INIFileName           : TimerValue = Val(tempz)
      GetPrivateProfileString "All", "TimerOn", "0", tempz, %Max_Path, INIFileName               : TimerOn = Val(tempz)
      GetPrivateProfileString "All", "AutoSizeMainFont", "1", tempz, %Max_Path, INIFileName      : AutoSizeMainFont = Val(tempz)
      GetPrivateProfileString "All", "MainMode", Str$(%CountDown), tempz, %Max_Path, INIFileName : MainMode = Val(tempz)
      GetPrivateProfileString "All", "OnTop", "0", tempz, %Max_Path, INIFileName                 : OnTop = Val(tempz)
      GetPrivateProfileString "All", "DisplayTime", "0", tempz, %Max_Path, INIFileName           : DisplayTime = Val(tempz)
      GetPrivateProfileString "All", "RunMinimized", "0", tempz, %Max_Path, INIFileName          : RunMinimized = Val(tempz)
      GetPrivateProfileString "All", "AlarmSound", "1", tempz, %Max_Path, INIFileName            : AlarmSound = Val(tempz)
      GetPrivateProfileString "All", "AlarmContinuous", "0", tempz, %Max_Path, INIFileName       : AlarmContinuous = Val(tempz)
      GetPrivateProfileString "All", "AlarmOn", "1", tempz, %Max_Path, INIFileName               : AlarmOn = Val(tempz)
      GetPrivateProfileString "All", "AlarmVisual", "0", tempz, %Max_Path, INIFileName           : AlarmVisual = Val(tempz)
      GetPrivateProfileString "All", "AlarmText", "0", tempz, %Max_Path, INIFileName             : AlarmText = Val(tempz)
      GetPrivateProfileString "All", "RunOnAlarm", "0", tempz, %Max_Path, INIFileName            : RunOnAlarm = Val(tempz)
      GetPrivateProfileString "All", "DisplayProgress", "0", tempz, %Max_Path, INIFileName       : DisplayProgress = Val(tempz)
      GetPrivateProfileString "All", "CenterOnAlarm", "0", tempz, %Max_Path, INIFileName         : CenterOnAlarm = Val(tempz)
      GetPrivateProfileString "All", "AutoExit", "0", tempz, %Max_Path, INIFileName              : AutoExit = Val(tempz)
      GetPrivateProfileString "All", "SlideShowOn", "0", tempz, %Max_Path, INIFileName           : SlideShowOn = Val(tempz)
      GetPrivateProfileString "All", "SlideShowInterval", "10", tempz, %Max_Path, INIFileName    : SlideShowInterval = Val(tempz)
      GetPrivateProfileString "All", "ColorsMode", Str$(%ColorYB), tempz, %Max_Path, INIFileName : ColorsMode = Val(tempz)
      GetPrivateProfileString "All", "AlarmWarning5", "0", tempz, %Max_Path, INIFileName         : AlarmWarning5 = Val(tempz)
      GetPrivateProfileString "All", "AlarmWarning1", "0", tempz, %Max_Path, INIFileName         : AlarmWarning1 = Val(tempz)
      GetPrivateProfileString "All", "AllowNegative", "0", tempz, %Max_Path, INIFileName         : AllowNegative = Val(tempz)
      GetPrivateProfileString "All", "RestoreOnAlarm", "1", tempz, %Max_Path, INIFileName         : RestoreOnAlarm = Val(tempz)
      GetPrivateProfileString "All", "MainFontSize", "68", tempz, %Max_Path, INIFileName         : MainFontSize = Val(tempz)
      GetPrivateProfileString "All", "MainClockFontSize", "20", tempz, %Max_Path, INIFileName    : MainClockFontSize = Val(tempz)
      GetPrivateProfileString "All", "MainFontAttr", "1", tempz, %Max_Path, INIFileName          : MainFontAttr = Val(tempz)
      GetPrivateProfileString "All", "MainClockFontAttr", "1", tempz, %Max_Path, INIFileName     : MainClockFontAttr = Val(tempz)
      GetPrivateProfileString "All", "MainCustomFG", Str$(%Black), tempz, %Max_Path, INIFileName : MainCustomFG = Val(tempz)
      GetPrivateProfileString "All", "MainCustomBG", Str$(%White), tempz, %Max_Path, INIFileName : MainCustomBG = Val(tempz)
      GetPrivateProfileString "All", "AllowSelectTA", "0", tempz, %Max_Path, INIFileName         : AllowSelectTA = Val(tempz)
      GetPrivateProfileString "All", "RatioXY", "2", tempz, %Max_Path, INIFileName               : RatioXY = Val(tempz)
      GetPrivateProfileString "All", "DisplayMode", Str$(%Image), tempz, %Max_Path, INIFileName  : DisplayMode = Val(tempz)
      GetPrivateProfileString "All", "AnimationMode", "1", tempz, %Max_Path, INIFileName         : AnimationMode = Val(tempz)
      GetPrivateProfileString "All", "SlideShow", "0", tempz, %Max_Path, INIFileName             : SlideShow = Val(tempz)
      GetPrivateProfileString "All", "GradientColorLeft", Str$(%Red), tempz, %Max_Path, INIFileName   : GradientColorLeft = Val(tempz)
      GetPrivateProfileString "All", "GradientColorRight", Str$(%Blue), tempz, %Max_Path, INIFileName : GradientColorRight = Val(tempz)
      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempz)
      Next i

   ElseIf Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      If IsFile(INIFileName) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "AlarmMessage", (AlarmMessage), INIFileName
      WritePrivateProfileString "All", "AlarmSoundFile", (AlarmSoundFile), INIFileName
      WritePrivateProfileString "All", "WarningSoundFile", (WarningSoundFile), INIFileName
      WritePrivateProfileString "All", "CFN", (CFN), INIFileName
      WritePrivateProfileString "All", "MainFontName", (MainFontName), INIFileName
      WritePrivateProfileString "All", "MainClockFontName", (MainClockFontName), INIFileName
      WritePrivateProfileString "All", "CustomTime", (CustomTime), INIFileName
      WritePrivateProfileString "All", "TimeOfDay", (TimeOfDay), INIFileName
      WritePrivateProfileString "All", "CFNListFile", (CFNListFile), INIFileName
      WritePrivateProfileString "All", "MainText", (MainText), INIFileName

      'save numeric variable
      WritePrivateProfileString "All", "CFNIndex", (Str$(CFNIndex)), INIFileName
      WritePrivateProfileString "All", "TimerMax", (Str$(TimerMax)), INIFileName
      WritePrivateProfileString "All", "TimerValue", (Str$(TimerValue)), INIFileName
      WritePrivateProfileString "All", "TimerOn", (Str$(TimerOn)), INIFileName
      WritePrivateProfileString "All", "AutoSizeMainFont", (Str$(AutoSizeMainFont)), INIFileName
      WritePrivateProfileString "All", "MainMode", (Str$(MainMode)), INIFileName
      WritePrivateProfileString "All", "OnTop", (Str$(OnTop)), INIFileName
      WritePrivateProfileString "All", "DisplayTime", (Str$(DisplayTime)), INIFileName
      WritePrivateProfileString "All", "RunMinimized", (Str$(RunMinimized)), INIFileName
      WritePrivateProfileString "All", "AlarmSound", (Str$(AlarmSound)), INIFileName
      WritePrivateProfileString "All", "AlarmContinuous", (Str$(AlarmContinuous)), INIFileName
      WritePrivateProfileString "All", "AlarmOn", (Str$(AlarmOn)), INIFileName
      WritePrivateProfileString "All", "AlarmVisual", (Str$(AlarmVisual)), INIFileName
      WritePrivateProfileString "All", "AlarmText", (Str$(AlarmText)), INIFileName
      WritePrivateProfileString "All", "RunOnAlarm", (Str$(RunOnAlarm)), INIFileName
      WritePrivateProfileString "All", "DisplayProgress", (Str$(DisplayProgress)), INIFileName
      WritePrivateProfileString "All", "CenterOnAlarm", (Str$(CenterOnAlarm)), INIFileName
      WritePrivateProfileString "All", "AutoExit", (Str$(AutoExit)), INIFileName
      WritePrivateProfileString "All", "SlideShowOn", (Str$(SlideShowOn)), INIFileName
      WritePrivateProfileString "All", "SlideShowInterval", (Str$(SlideShowInterval)), INIFileName
      WritePrivateProfileString "All", "ColorsMode", (Str$(ColorsMode)), INIFileName
      WritePrivateProfileString "All", "AlarmWarning5", (Str$(AlarmWarning5)), INIFileName
      WritePrivateProfileString "All", "AlarmWarning1", (Str$(AlarmWarning1)), INIFileName
      WritePrivateProfileString "All", "AllowNegative", (Str$(AllowNegative)), INIFileName
      WritePrivateProfileString "All", "RestoreOnAlarm", (Str$(RestoreOnAlarm)), INIFileName
      WritePrivateProfileString "All", "MainFontSize", (Str$(MainFontSize)), INIFileName
      WritePrivateProfileString "All", "MainClockFontSize", (Str$(MainClockFontSize)), INIFileName
      WritePrivateProfileString "All", "MainFontAttr", (Str$(MainFontAttr)), INIFileName
      WritePrivateProfileString "All", "MainClockFontAttr", (Str$(MainClockFontAttr)), INIFileName
      WritePrivateProfileString "All", "MainCustomFG", (Str$(MainCustomFG)), INIFileName
      WritePrivateProfileString "All", "MainCustomBG", (Str$(MainCustomBG)), INIFileName
      WritePrivateProfileString "All", "AllowSelectTA", (Str$(AllowSelectTA)), INIFileName
      WritePrivateProfileString "All", "RatioXY", (Str$(RatioXy)), INIFileName
      WritePrivateProfileString "All", "DisplayMode", (Str$(DisplayMode)), INIFileName
      WritePrivateProfileString "All", "AnimationMode", (Str$(AnimationMode)), INIFileName
      WritePrivateProfileString "All", "SlideShow", (Str$(SlideShow)), INIFileName
      WritePrivateProfileString "All", "GradientColorLeft", (Str$(GradientColorLeft)), INIFileName
      WritePrivateProfileString "All", "GradientColorRight", (Str$(GradientColorRight)), INIFileName
      For i = 0 To 15
         tempz = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), tempz, INIFileName
      Next i
   End If
End Sub

Sub CreateContextMenu
   Menu New PopUp To hMain
   Menu Add String, hMain, "Text Only", %IDM_TextOnly, %MF_Enabled
   Menu Add String, hMain, "Image", %IDM_Image, %MF_Enabled
   Menu Add String, hMain, "Gradient", %IDM_Gradient, %MF_Enabled
   Menu Add String, hMain, "Animation", %IDM_Animation, %MF_Enabled
   Menu Add String, hMain, "-", %IDM_Sep, 0
   Menu Add String, hMain, "Current Time", %IDM_DisplayTime, %MF_Enabled
   Menu Add String, hMain, "On/Off Status (Red Dot)", %IDM_ShowOffStatus, %MF_Enabled
   Menu Add String, hMain, "Show Text Area Rectangle", %IDM_ShowCFNRect, %MF_Enabled
   Menu Add String, hMain, "-", %IDM_Sep, 0
   Menu Add String, hMain, "Matrix Animation", %IDM_Matrix, %MF_Enabled
   Menu Add String, hMain, "Stereogram Animation", %IDM_Stereogram, %MF_Enabled
   Menu Add String, hMain, "Falling Sand", %IDM_FallingSand, %MF_Enabled
   Menu Add String, hMain, "-", %IDM_Sep, 0
   Menu Add String, hMain, "Select/Add Image", %IDM_SelectMainImage, %MF_Enabled
   Menu Add String, hMain, "Remove Image", %IDM_RemoveImage, %MF_Enabled

   Menu New PopUp To hAutoRun
   Menu Add String, hAutoRun, "Run On Alarm", %IDM_RunOnAlarm, %MF_Enabled
   Menu Add String, hAutoRun, "-", %IDM_Sep, 0
   Menu Add String, hAutoRun, "Run Now", %IDM_RunNow, %MF_Enabled
   Menu Add String, hAutoRun, "Select App", %IDM_SelectApp, %MF_Enabled

   Menu New PopUp To hColors
   Menu Add String, hColors, "Black-White", %IDM_ColorBW, %MF_Enabled
   Menu Add String, hColors, "Yellow-Blue", %IDM_ColorYB, %MF_Enabled
   Menu Add String, hColors, "Gray-Gray", %IDM_ColorGG, %MF_Enabled
   Menu Add String, hColors, "Custom Colors", %IDM_ColorCustom, %MF_Enabled
   Menu Add String, hColors, "-", %IDM_Sep, 0
   Menu Add String, hColors, "Select Custom FG", %IDM_MainFG, %MF_Enabled
   Menu Add String, hColors, "Select Custom BG", %IDM_MainFG, %MF_Enabled
   Menu Add String, hColors, "-", %IDM_Sep, 0
   Menu Add String, hColors, "Select Gradient Color Left", %IDM_GradientColorLeft, %MF_Enabled
   Menu Add String, hColors, "Select Gradient Color Right", %IDM_GradientColorRight, %MF_Enabled

   Menu New PopUp To hSlideShow
   Menu Add String, hSlideShow, "Off", %IDM_Speed0, %MF_Enabled
   Menu Add String, hSlideShow, "5 sec Interval", %IDM_Speed5, %MF_Enabled
   Menu Add String, hSlideShow, "10 sec Interval", %IDM_Speed10, %MF_Enabled
   Menu Add String, hSlideShow, "30 sec Interval", %IDM_Speed30, %MF_Enabled

   Menu New PopUp To hFonts
   Menu Add String, hFonts, "Select Timer Font", %IDM_SelectMainFont, %MF_Enabled
   Menu Add String, hFonts, "AutoSize Timer Font", %IDM_AutoSizeMainFont, %MF_Enabled
   Menu Add String, hFonts, "-", %IDM_Sep, 0
   Menu Add String, hFonts, "Select Current Time Font", %IDM_SelectMainClockFont, %MF_Enabled

   Menu New PopUp To hAlarm
   Menu Add String, hAlarm, "On", %IDM_AlarmOn, %MF_Enabled
   Menu Add String, hAlarm, "-", %IDM_Sep, 0
   Menu Add String, hAlarm, "Sound", %IDM_Sound, %MF_Enabled
   Menu Add String, hAlarm, "Visual", %IDM_Visual, %MF_Enabled
   Menu Add String, hAlarm, "Text", %IDM_DisplayAlarmText, %MF_Enabled
   Menu Add String, hAlarm, "5-Minute Warning", %IDM_Warning5, %MF_Enabled
   Menu Add String, hAlarm, "1-Minute Warning", %IDM_Warning1, %MF_Enabled
   Menu Add String, hAlarm, "-", %IDM_Sep, 0
   Menu Add String, hAlarm, "CountDown", %IDM_CountDown, %MF_Enabled
   Menu Add String, hAlarm, "CountUp", %IDM_CountUp, %MF_Enabled
   Menu Add String, hAlarm, "Clock", %IDM_Clock, %MF_Enabled
   Menu Add String, hAlarm, "-", %IDM_Sep, 0
   Menu Add String, hAlarm, "AutoExit on Alarm",  %IDM_AutoExit, %MF_Enabled
   Menu Add String, hAlarm, "Allow Negative Time", %IDM_Negative, %MF_Enabled
   Menu Add String, hAlarm, "Restore On Alarm", %IDM_RestoreOnAlarm, %MF_Enabled
   Menu Add String, hAlarm, "Continuous Alarm", %IDM_Continuous, %MF_Enabled

   Menu Add String, hAlarm, "-", %IDM_Sep, 0
   Menu Add String, hAlarm, "Enter Alarm Text", %IDM_AlarmText, %MF_Enabled

   Menu Add String, hAlarm, "-", %IDM_Sep, 0
   Menu Add String, hAlarm, "Select Alarm Sound", %IDM_SelectAlarm, %MF_Enabled
   Menu Add String, hAlarm, "Test Alarm", %IDM_TestAlarm, %MF_Enabled
   Menu Add String, hAlarm, "Select Warning Sound", %IDM_SelectWarning, %MF_Enabled
   Menu Add String, hAlarm, "Test Warning", %IDM_TestWarning, %MF_Enabled

   Menu New PopUp To hMinutes
   Menu Add String, hMinutes, "1", %IDM_Minutes01, %MF_Enabled
   Menu Add String, hMinutes, "5", %IDM_Minutes05, %MF_Enabled
   Menu Add String, hMinutes, "10", %IDM_Minutes10, %MF_Enabled
   Menu Add String, hMinutes, "Custom (2:00)", %IDM_MinutesCustom, %MF_Enabled
   Menu Add String, hMinutes, "Time-of-Day (17:00)", %IDM_MinutesTimeOfDay, %MF_Enabled

   Menu New PopUp To hContext
   Menu Add String, hContext, "Start/Continue", %IDM_Start, %MF_Enabled
   Menu Add String, hContext, "Reset", %IDM_Reset, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, 0

   Menu Add PopUp,  hContext, "Display", hMain, %MF_Enabled
   Menu Add PopUp,  hContext, "Timer", hMinutes, %MF_Enabled
   Menu Add PopUp,  hContext, "Alarm", hAlarm, %MF_Enabled
   Menu Add PopUp,  hContext, "Colors", hColors, %MF_Enabled
   Menu Add PopUp,  hContext, "Fonts", hFonts, %MF_Enabled
   Menu Add PopUp,  hContext, "SlideShow", hSlideShow, %MF_Enabled
   Menu Add PopUp,  hContext, "AutoRun Application", hAutoRun, %MF_Enabled

   Menu Add String, hContext, "-", %IDM_Sep, 0
   Menu Add String, hContext, "On Top", %IDM_OnTop, %MF_Enabled
   Menu Add String, hContext, "Allow Text Area Selection", %IDM_AllowSelectTA, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, 0
   Menu Add String, hContext, "Minimize",  %IDM_Minimize, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, 0
   Menu Add String, hContext, "Help",  %IDM_Help, %MF_Enabled
   Menu Add String, hContext, "About",  %IDM_About, %MF_Enabled
   Menu Add String, hContext, "Exit",  %IDM_Exit, %MF_Enabled
End Sub

Function GetAlarmMessage() As String
    Local temp$
    temp$ = Trim$(InputBox$("Enter alarm text:", "Alarm Text", AlarmMessage, 100, 100))
    If Len(temp$) Then AlarmMessage = temp$
End Function

Function EnterCustomMinutes() As Long
    Local temp$
    temp$ = Trim$(InputBox$("Enter minutes as 'mm:ss'", "Custom Time", CustomTime, 100, 100))
    If Len(temp$) Then
        CustomTime = temp$
        Menu Set Text hContext, ByCmd %IDM_MinutesCustom, "Custom (" & CustomTime & ")"
        TimerMax = 60 * Val(Parse$(temp$,":",1)) + Val(Parse$(temp$,":",21))
    End If
End Function

Function SetTimeOfDayMinutes() As Long
    Local temp$
    temp$  = Trim$(InputBox$("Enter time of day when alarm will sound (hh:mm:ss), in 24-hour format: ", "Time Of Day", TimeOfDay, 100,100))
    If Len(temp$) Then
        TimeofDay = temp$
        Menu Set Text hContext, ByCmd %IDM_MinutesTimeOfDay, "Time of Day (" + TimeOfDay + ")"
        TimerMax = 60*60*Val(Parse$(TimeOfDay,":",1)) + 60*Val(Parse$(TimeOfDay,":",2)) + Val(Parse$(TimeOfDay,":",3)) - _
                   60*60*Val(Parse$(Time$,":",1)) + 60*Val(Parse$(Time$,":",2)) + Val(Parse$(Time$,":",3))
    End If
End Function

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   Display Font hDlg, 100,100, MainFontName, MainFontSize, MainFontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then MainFontName = fName : MainFontSize = fPoints : MainFontAttr = fStyle
End Sub

Sub SelectMainClockFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   Display Font hDlg, 100,100, MainClockFontName, MainClockFontSize, MainClockFontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then MainClockFontName = fName : MainClockFontSize = fPoints : MainClockFontAttr = fStyle
End Sub

Sub SelectAlarmSound
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select Alarm Sound"
    filter$ = "WAV" + $Nul + "*.wav;*.mid;*.mp3" + $Nul
    startfolder$ = AlarmSoundFile
    startfile$ = AlarmSoundFile
    defaultext$ = ""
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then AlarmSoundFile = filevar$
End Sub

Sub SelectWarningSound
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select Warning Sound"
    filter$ = "WAV" + $Nul + "*.wav;*.mid;*.mp3" + $Nul
    startfolder$ = WarningSoundFile
    startfile$ = WarningSoundFile
    defaultext$ = ""
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then WarningSoundFile = filevar$
End Sub

Sub SelectApplication
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select Alarm Applicaton"
    filter$ = "EXE" + $Nul + "*.exe" + $Nul
    startfolder$ = AlarmApp
    startfile$ = AlarmApp
    defaultext$ = ""
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then AlarmApp = filevar$
End Sub

Sub RunApplicationNow
   Shell(AlarmApp, 1)  'does not wait
End Sub

Sub TestAlarmSound
    Select Case Right$(LCase$(AlarmSoundFile),4)
        Case ".wav"
            sndPlaySound((AlarmSoundFile), %SND_Async)   'play once, in background
        Case ".mp3"
            ? "mp3"
        Case ".mid"
            MCISendString "open type midiaudio", ByVal 0, 0, 0
            MCISendString "PLAY " + AlarmSoundFile, ByVal 0, 0, 0
    End Select
End Sub

Sub PLayWarning
    sndPlaySound((WarningSoundFile), %SND_Async)   'play once, in background
End Sub

Sub SoundAlarm
    'iReturn = sndPlaySound("", %SND_ASYNC)   'stop once song has started    If AlarmSound Then
    If AlarmSound Then
        Select Case Right$(LCase$(AlarmSoundFile),4)
            Case ".wav"
                If AlarmContinuous Then
                   sndPlaySound((AlarmSoundFile), %SND_Async Or %SND_Loop)  'play continuously
                Else
                   sndPlaySound((AlarmSoundFile), %SND_Async)   'play once, in background
                End If
            Case ".mp3"
                ? "mp3"
            Case ".mid"
                MCISendString "open type midiaudio", ByVal 0, 0, 0
                MCISendString "PLAY " + AlarmSoundFile, ByVal 0, 0, 0
        End Select
    End If

    If AlarmVisual Then
        'flash timer value (negative image)
    End If

    If AlarmText Then
        'flash timer value (negative)
    End If

    If RunOnAlarm Then
        If Len(Dir$(AlarmApp)) Then Shell(AlarmApp, 1)  'does not wait
    End If
End Sub

Sub SetOnTop
    If OnTop Then
       SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE)  'on Top
    Else
       SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE) 'not on Top
    End If
End Sub

Sub OpenWebPage
   Local tempAsciiz As AsciiZ * %Max_Path, iReturn As Long
   tempAsciiZ = "http://www.garybeene.com/sw/gbofficetimer.htm"
   iReturn = ShellExecute(hDlg, "Open", tempAsciiZ, $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub OpenAboutDialog
   Local OldTop As Long
   OldTop = OnTop : OnTop = 0 : SetOnTop
   MsgBox "gbOfficeTimer " + $ver, %MB_Ok + %MB_IconInformation, "About"
   OnTop = OldTOp : SetOnTop
End Sub

Sub ShowSettings
   Local temp$, i As Long
   temp$ = "Main Image: " + CFN
   For i = 0 To UBound(ROIData)
       If CFN = CFNList(i) Then
           temp$ = temp$ + $CrLf + Str$(ROIData(i).nLeft) + Str$(ROIData(i).nTop) + Str$(ROIData(i).nRight) + Str$(ROIData(i).nBottom)
           Exit For
       End If
   Next i
'   temp$ = temp$ + $CrLf + "Message Image: " + PanelImage
   MsgBox "Settings:" + $CrLf + temp$, %MB_Ok + %MB_IconInformation, "About"
End Sub

Sub ShowNextImage(i As Long)
    If i = 1 Then
        Incr CFNIndex
        If CFNIndex > UBound(CFNList) Then CFNIndex = 0
    Else
        Decr CFNIndex
        If CFNIndex < 0 Then CFNIndex = UBound(CFNList)
    End If
    CFN = CFNList(CFNIndex)
    GetROIFromROIData           'get ROI and adjust to current dialog size
End Sub

Sub SelectRandomImage
    CFNIndex = Rnd(0, UBound(CFNList))
    CFN = CFNList(CFNIndex)
    GetROIFromROIData             'get ROI and adjust to current dialog size
End Sub

Sub StartTimer
    SetTimer hDlg, %Timer_Main, 1000, ByVal %NULL
'   Dialog Post hDlg, %WM_Timer, %Timer_Main, 0     ' optional - forces an initial %WM_TIMER "event"
End Sub

Sub StopTimer
    KillTimer hDlg, %Timer_Main
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "main_images") = %False Then MkDir Exe.Path$ + "main_images\"
   If IsFolder (Exe.Path$ + "panel_images") = %False Then MkDir Exe.Path$ + "panel_images\"
   If IsFolder (Exe.Path$ + "support") = %False Then MkDir Exe.Path$ + "support\"
End Sub

Sub SetMenus
    'start/continue  n/a
    Menu Set Text hContext, ByCmd %IDM_Start, IIf$(TimerOn, "Pause", "Start/Continue")
    'reset  n/a

    'display
    Menu Set State hContext, ByCmd %IDM_TextOnly, 0
    Menu Set State hContext, ByCmd %IDM_Image, 0
    Menu Set State hContext, ByCmd %IDM_Gradient, 0
    Menu Set State hContext, ByCmd %IDM_Animation, 0
    Select Case DisplayMode
        Case %TextOnly    : Menu Set State hContext, ByCmd %IDM_TextOnly, 8
        Case %Image       : Menu Set State hContext, ByCmd %IDM_Image, 8
        Case %Gradient    : Menu Set State hContext, ByCmd %IDM_Gradient, 8
        Case %Animation   : Menu Set State hContext, ByCmd %IDM_Animation, 8
    End Select
    Menu Set State hContext, ByCmd %IDM_Matrix, 0
    Menu Set State hContext, ByCmd %IDM_Stereogram, 0
    Menu Set State hContext, ByCmd %IDM_FallingSand, 0
    Select Case AnimationMode
        Case %Matrix      : Menu Set State hContext, ByCmd %IDM_Matrix, 8
        Case %Stereogram  : Menu Set State hContext, ByCmd %IDM_Stereogram, 8
        Case %FallingSand : Menu Set State hContext, ByCmd %IDM_FallingSand, 8
    End Select
    Menu Set State hContext, ByCmd %IDM_DisplayTime, DisplayTime * 8   'current time
    Menu Set State hContext, ByCmd %IDM_ShowOffStatus, ShowOffStatus * 8   'show timer off with red dot
    'select image
    'select random image

    'timer
    Menu Set State hContext, ByCmd %IDM_Minutes01, 0  '1
    Menu Set State hContext, ByCmd %IDM_Minutes05, 0  '5
    Menu Set State hContext, ByCmd %IDM_Minutes10, 0  '10
    Menu Set State hContext, ByCmd %IDM_MinutesCustom, 0
    Menu Set State hContext, ByCmd %IDM_MinutesTimeOfDay, 0
    Select Case TimerMax
        Case 1  : Menu Set State hContext, ByCmd %IDM_Minutes01, 8     '1
        Case 5  : Menu Set State hContext, ByCmd %IDM_Minutes05, 8     '5
        Case 10 : Menu Set State hContext, ByCmd %IDM_Minutes10, 8     '10
        Case -1 : Menu Set State hContext, ByCmd %IDM_MinutesCustom, 8 'custom
        Case -2 : Menu Set State hContext, ByCmd %IDM_MinutesTimeOfDay, 8 'time of day
    End Select

    'colors
    Menu Set State hContext, ByCmd %IDM_ColorBW, 0     'b-w
    Menu Set State hContext, ByCmd %IDM_ColorYB, 0     'y-b
    Menu Set State hContext, ByCmd %IDM_ColorGG, 0     'g-g
    Menu Set State hContext, ByCmd %IDM_ColorCustom, 0 'custom colors
    Select Case ColorsMode
        Case %colorbw      : Menu Set State hContext, ByCmd %IDM_ColorBW, 8      'b-w
        Case %coloryb      : Menu Set State hContext, ByCmd %IDM_ColorYB, 8      'y-b
        Case %colorgg      : Menu Set State hContext, ByCmd %IDM_ColorGG, 8      'g-g
        Case %colorcustom  : Menu Set State hContext, ByCmd %IDM_ColorCustom, 8  'custom
    End Select
    'select main fg
    'select main bg

    'fonts
    'select timer font
    Menu Set State hContext, ByCmd %IDM_AutoSizeMainFont, AutoSizeMainFont * 8        'autosize main font
    'select current time font

    'alarm
    Menu Set State hContext, ByCmd %IDM_AlarmOn, AlarmOn * 8
    Menu Set State hContext, ByCmd %IDM_Sound, AlarmSound * 8                        'on
    Menu Set State hContext, ByCmd %IDM_Continuous, AlarmContinuous * 8        'continous
    Menu Set State hContext, ByCmd %IDM_Visual, AlarmVisual * 8                'visual
    Menu Set State hContext, ByCmd %IDM_DisplayAlarmText, AlarmText * 8  'message
    Menu Set State hContext, ByCmd %IDM_Warning5, AlarmWarning5 * 8            'warning5
    Menu Set State hContext, ByCmd %IDM_Warning1, AlarmWarning1 * 8            'warning1
    Menu Set State hContext, ByCmd %IDM_CountDown, 0  'countdown
    Menu Set State hContext, ByCmd %IDM_CountUp, 0    'countup
    Menu Set State hContext, ByCmd %IDM_Clock, 0      'clock
    Select Case MainMode
       Case %countdown : Menu Set State hContext, ByCmd %IDM_CountDown, %MF_Checked   'countdown
       Case %countup   : Menu Set State hContext, ByCmd %IDM_CountUp, %MF_Checked     'countup
       Case %clock     : Menu Set State hContext, ByCmd %IDM_Clock, %MF_Checked       'clock
    End Select
    Menu Set State hContext, ByCmd %IDM_AutoExit, AutoExit * 8   'autoexit
    Menu Set State hContext, ByCmd %IDM_Negative, AllowNegative * 8            'allow negative
    Menu Set State hContext, ByCmd %IDM_RestoreOnAlarm, RestoreOnAlarm * 8            'allow negative
    'enter alarm text
    'select alarm sound file
    'test alarm
    'select warning sound file
    'test warning

    'slideshow
    Menu Set State hContext, ByCmd %IDM_Speed0, 0 ' Off
    Menu Set State hContext, ByCmd %IDM_Speed5, 0 ' 5 sec interval
    Menu Set State hContext, ByCmd %IDM_Speed10, 0 '10 sec interval
    Menu Set State hContext, ByCmd %IDM_Speed30, 0 '30 sec interval
    Select Case SlideShowInterval
        Case 0  : Menu Set State hContext, ByCmd %IDM_Speed0, 8 ' 5 sec interval
        Case 5  : Menu Set State hContext, ByCmd %IDM_Speed5, 8 ' 5 sec interval
        Case 10 : Menu Set State hContext, ByCmd %IDM_Speed10, 8 '10 sec interval
        Case 30 : Menu Set State hContext, ByCmd %IDM_Speed30, 8 '30 sec interval
    End Select

    'autorun
    Menu Set State hContext, ByCmd %IDM_RunOnAlarm, RunOnAlarm * 8   'run on alarm
    'run now
    'select app

    Menu Set State hContext, ByCmd %IDM_OnTop, OnTop * 8   'ontop
    Menu Set State hContext, ByCmd %IDM_AllowSelectTA, AllowSelectTA * 8   'allow select text area

    'help
    'about
    'exit

End Sub

Sub GetROIFromROIData
    Local w,h As Long
    Dialog Get Client hDlg To w,h
    'get ROI from ROIData(), adjusted for w/h of dialog.
    ROI.nLeft   = ROIData(CFNIndex).nLeft * w / 400
    ROI.nTop    = ROIData(CFNIndex).nTop * w / 400
    ROI.nRight  = ROIData(CFNIndex).nRight * w / 400
    ROI.nBottom = ROIData(CFNIndex).nBottom * w / 400
End Sub

Sub ResizeWindows
    Local w,h As Long
    Dialog Get Client hDlg To w,h
    Control Set Size hDlg, %IDC_Main, w,h
    GetROIFromROIData
    DrawROIContent
End Sub

Sub SetROIElements
   ROI.nLeft = Min(R.nLeft,R.nRight)           'order elements as needed for DrawFocusRect
   ROI.nRight = Max(R.nLeft,R.nRight)
   ROI.nTop = Min(R.nTop,R.nBottom)
   ROI.nBottom = Max(R.nTop,R.nBottom)
End Sub

Sub StoreROI
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   ROIData(CFNIndex).nLeft = ROI.nLeft * 400 / w   'put ROI in ROIData(), adjusted to 400x200 image size
   ROIData(CFNIndex).nTop = ROI.nTop * 400 / w
   ROIData(CFNIndex).nRight = ROI.nRight * 400 / w
   ROIData(CFNIndex).nBottom = ROI.nBottom * 400 / w
End Sub

Sub DrawFocusRectangle(Flag As Long)    '1=moving 0=done
   hDC = GetDC(hDlg)
   DrawFocusRect hDC, R2                'erase old rectangle
   If Flag Then DrawFocusRect hDC, ROI  'draw the new
   ReleaseDC hDlg, hDC
End Sub

Sub xDrawFocusRectangle(Flag As Long)    '1=moving 0=done
   Graphic Attach hDlg, %IDC_Main
   Graphic Set Mix %Mix_NotXorSrc
   Graphic Style 2   'dash
   Graphic Box (R2.nLeft,R2.nTop)-(R2.nRight,R2.nBottom),0,%Black   'erase old
   If Flag Then Graphic Box (ROI.nLeft,ROI.nTop)-(ROI.nRight,ROI.nBottom),0,%Black   'erase old
   Graphic Set Mix %Mix_CopySrc
   Graphic Style 0   'solid
End Sub

Function GetCFNIndex() As Long
    'if in list, use value, else use full 400x200
    Local i As Long
    For i = 0 To UBound(CFNList)
        If CFNList(i) = CFN Then Function = i : Exit Function
    Next i
    Function = -1
End Function

Sub LoadCFNList
    'load TAData()
    Local fName As String, i,iCount, nLeft, nTop, nBottom, nRight As Long
    Open CFNListFile For Input As #1
    FileScan #1, Records To iCount
    If iCount Then
        ReDim CFNList(-1 To iCount-1), ROIData(-1 To iCount-1)  '-1 mean TextOnly
        CFNList(-1) = "TextOnly"
        ROIData(-1).nLeft = 0 : ROIData(-1).nTop = 0 : ROIData(-1).nRight = 400 : ROIData(-1).nBottom = 200
        iCount = -1
        For i = 0 To UBound(CFNList)
            Input #1, fName, nLeft, nTop, nRight, nBottom
            If Len(Dir$(Trim$(fName))) Then
                Incr iCount
                CFNList(iCount) = LCase$(fName)
                ROIData(iCount).nLeft = nLeft
                ROIData(iCount).nTop = nTop
                ROIData(iCount).nRight = nRight
                ROIData(iCount).nBottom = nBottom
            End If
        Next i
    Else
        MsgBox "Error: No messages found!", %MB_Ok + %MB_IconInformation, "Load Iamge Data"
    End If
    Close #1
End Sub

Sub WriteCFNData
    'could do binary write, but want text file so user can edit if required
    Local i As Long
    Open CFNListFile For Output As #1
    For i = 0 To UBound(CFNList)
       Write #1, LCase$(CFNList(i)), ROIData(i).nLeft, ROIData(i).nTop, ROIData(i).nRight, ROIData(i).nBottom
    Next i
    Close #1
End Sub

Sub CreateCFNListFile
    Local temp$
    Open CFNListFile For Output As #1
    temp$ = Dir$(Exe.Path$ + "main_images\*.bmp")
    While Len(temp$)
       Write #1, LCase$(Exe.Path$ + "main_images\" + temp$), 20,20,380,180
       temp$ = Dir$(Next)
    Wend
    Close #1
End Sub

Function BigChange() As Long
    Local MinDelta As Long
    MinDelta = 20
    If Abs(ROI.nTop-ROI.nBottom) > MinDelta Or Abs(ROI.nLeft-ROI.nRight) > MinDelta Then
        Function = 1
        Exit Function
    End If
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(4)
   ac(c).fvirt = %FVIRTKEY          : ac(c).key   = %VK_F2 : ac(c).cmd   = %IDM_SelectRandomImage  : Incr c  'random image
   ac(c).fvirt = %FVIRTKEY          : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDM_DefaultSize        : Incr c  '400x200
   ac(c).fvirt = %FVIRTKEY          : ac(c).key   = %VK_F4 : ac(c).cmd   = %IDM_ShowTAValues       : Incr c  '400x200
   ac(c).fvirt = %FVIRTKEY          : ac(c).key   = %VK_F5 : ac(c).cmd   = %IDM_ShowNextImage      : Incr c  '400x200
   ac(c).fvirt = %FVIRTKEY          : ac(c).key   = %VK_F6 : ac(c).cmd   = %IDM_Gradient           : Incr c  '400x200
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub ShowTAValues
    ? Str$(ROI.nLeft) + Str$(ROI.nTop) + Str$(ROI.nRight) + Str$(ROI.nBottom)
    ? Str$(CFNIndex) + Str$(ROIData(CFNIndex).nLeft) + Str$(ROIData(CFNIndex).nTop) + Str$(ROIData(CFNIndex).nRight) + Str$(ROIData(CFNIndex).nBottom)
End Sub

Function NewMainProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case Msg
      Case %WM_MouseWheel
         If DisplayMode = %Image Then
             Select Case Hi(Integer,wParam)    'note the use of Integer
               Case > 0 : ShowNextImage(1) : DrawROIContent
               Case < 0 : ShowNextImage(-1) : DrawROIContent
             End Select
         End If
   End Select
   Function = CallWindowProc(OldProc, hWnd, Msg, wParam, lParam)
End Function

Sub SetColors
    Select Case ColorsMode
        Case %ColorBW     : MainFG = %Black        : MainBG = %White
        Case %ColorYB     : MainFG = %Yellow       : MainBG = %Blue
        Case %ColorGG     : MainFG = %rgb_DarkGray : MainBG = %rgb_LightGray
        Case %ColorCustom : MainFG = MainCustomFG  : MainBG = MainCustomBG
    End Select
End Sub

Sub SetFontSize
    Local Lower,Upper,x,y,fSize As Long, ScaleFactor As Single
    Lower = 1 : Upper = 1000 : ScaleFactor = 1.0
    Do Until (Upper <= (Lower + 1))
        fSize = (Lower + Upper) / 2
        Font New MainFontName, fSize, MainFontAttr To hFontMain
        Graphic Set Font hFontMain
        Graphic Text Size MainText To x,y
        If (x < ScaleFactor*(ROI.nRight-ROI.nLeft)) And (y < ScaleFactor*(ROI.nBottom-ROI.nTop)) Then
           Lower = fSize       'fits inside
        Else
           Upper = fSize      'goes outside
        End If
    Loop
End Sub

Sub DrawROIContent
   Local w,h,x,y As Long, scalefactor As Single
   Dialog Get Client hDlg To w,h

   scalefactor = 1

   'main IMAGE
'   Graphic Attach hDlg, %IDC_Main, ReDraw
   Select Case DisplayMode
       Case %TextOnly          : Graphic Color MainFG, MainBG
       Case %Image             : Graphic Color -1, -2  : Graphic Render CFN, (0,0)-(w,h)
       Case %Gradient          : Graphic Color MainFG, -2  : Gradient
       Case %Animation         : Graphic Color -1, -2
   End Select
   Graphic Clear

    'main TEXT
    If DisplayMode = %TextOnly Or DisplayMode = %Image Or DisplayMode = %Gradient Then
        MainText = IIf$(TimerValue<0,"-","") + Trim$(Str$(Abs(TimerValue) \ 60)) + ":" + Format$(Abs(TimerValue) Mod 60,"00")
        SetFontSize
        Graphic Text Size MainText To x,y
        Graphic Set Pos (ROI.nLeft + (ROI.nRight-ROI.nLeft-x)/2, ROI.nTop + (ROI.nBottom-ROI.nTop-y)/2)
        Graphic Print MainText
    End If

   'non-Mode display options  (red dot, current time, TARect)
   If TimerOn = 0 And ShowOffStatus Then Graphic Ellipse (5,5)-(20,20), %Red, %Red
   If ShowCFNRect Then Graphic Box (ROI.nLeft,ROI.nTop)-(ROI.nRight,ROI.nBottom),,%Red
   If DisplayTime Then
       Graphic Set Pos (IIf(TimerOn,10,30),5)
       Graphic Set Font hFontMainClock
       Graphic Print Time$
   End If

   Graphic ReDraw
End Sub

Sub Gradient
   Local x,w,h,CR1,CG1,CB1,CR2,CG2,CB2 As Long
   Dialog Get Client hDlg To w,h
   CR1 = GetRValue(GradientColorLeft)
   CG1 = GetGValue(GradientColorLeft)
   CB1 = GetBValue(GradientColorLeft)
   CR2 = GetRValue(GradientColorRight)
   CG2 = GetGValue(GradientColorRight)
   CB2 = GetBValue(GradientColorRight)
   For x = 0 To w
      Graphic Line (x,0) - (x,h), RGB( _
      (CR1 + (CR2-CR1)*x/w), _
      (CG1 + (CG2-CG1)*x/w), _
      (CB1 + (CB2-CB1)*x/w))
   Next
'   For x = 0 To w
'       Graphic Line (x,0) - (x,h), RGB(x/w*128, x/w*255, x/w*64)
'   Next
End Sub

Sub RemoveImage
    'remove CFN, update array, do NOT delete file
    If UBound(CFNList) = 0 Then
        MsgBox "Last image (cannot be removed)!", %MB_Ok + %MB_IconExclamation, "Remove Image"
        Exit Sub
    End If
    Array Delete CFNList(CFNIndex)
    Array Delete ROIData(CFNIndex)
    ReDim Preserve CFNList(-1 To UBound(CFNList)-1)
    ReDim Preserve ROIData(-1 To UBound(ROIData)-1)
    If CFNIndex > UBound(CFNList) Then Decr CFNIndex
    CFN = CFNList(CFNIndex)
    GetROIFromROIData  'get ROI and adjust to current dialog size
End Sub


Sub SelectMainImage
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   Local i,w,h As Long, temp$

   title$ = "Open File"
   filter$ = "Images" + $Nul + "*.bmp;*.jpg;*.gif;*.png" + $Nul
   startfolder$ = CFN
   startfile$ = CFN
   defaultext$ = ""
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then LoadImageFile(LCase$(filevar$))
End Sub

Sub LoadImageFile(fName As String)
   Local pGraphics, pImage,hBMP,hBMPtemp, hBMPDC As Dword, strFileName As String
   Local token As Dword, StartupInput As GdiplusStartupInput
   Local i,w,h,x1,x2,y1,y2,wCont,hCont,wNew,hNew As Long

   'if in CFNList - assumed to be *.bmp, 400x200
   For i = 0 To UBound(CFNList)
       If fName = CFNList(i) Then
           CFN = LCase$(fName$)
           CFNIndex = GetCFNIndex
           GetROIFromROIData
           Exit Sub
       End If
   Next i

   'if in main_image folder and is *.bmp (user should not put any files in main_image folder)
   If Right$(fName,4) = ".bmp" And Len(Dir$(Exe.Path$ + "main_images\" + PathName$(Namex, fName))) Then
       AddToCFNList fName
       Exit Sub
   End If


   'else read image, convert to 400x200 *.bmp and save in main_image folder
   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load/display image onto Graphic control
   strFileName = UCode$(fName)                         'image source file
   GdipLoadImageFromFile(StrPtr(strFileName), pImage)  'pImage - image object
   GdipGetImageWidth(pImage,w)
   GdipGetImageHeight(pImage,h)

   'place to put the image
   Graphic Bitmap New w,h To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hBMPDC

   GdipCreateFromHDC(hBMPDC, pGraphics)                  'pGraphics - graphic object
   GdipDrawImageRectI pGraphics, pImage, 0, 0, w-1, h-1  'draw on graphic object - hBMP now contains image from file

   'cleanup
   If pImage Then GdipDisposeImage(pImage)         'delete image object
   If pGraphics Then GdipDeleteGraphics(pGraphics) 'delete graphic object
   GdiplusShutdown token                           ' Shutdown GDI+

    'get size of largest 2:1 aspect ratio rectangle that will fit in image of size w,h
    wNew = 2 / Max(2 / w, 1 / h)
    hNew = 1 / Max(2 / w, 1 / h)

    'center that rectangle in w,h (get the top/left/right/bottom coordinates)
    x1 = (w-wNew)/2
    x2 = w - x1
    y1 = (h-hNew)/2
    y2 = h - y1

   'resize
   Graphic Bitmap New 400,200 To hBMPtemp
   Graphic Attach hBMPtemp, 0
   Graphic Set StretchMode %HalfTone
   Graphic Stretch hBMP, 0, (x1,y1)-(x2,y2) To (0,0)-(400,200)
   Graphic Save Exe.Path$ + "main_images\" + PathName$(Name, fName)+ ".bmp"

   AddToCFNList fName

   'clean up
   Graphic Bitmap End
   Graphic Attach hBMP,0
   Graphic Bitmap End
   Graphic Attach hDlg, %IDC_Main  'grpahic control has
End Sub

Sub AddToCFNList(fName As String)
   'add to CFN
   ReDim Preserve CFNList(-1 To UBound(CFNList)+1)
   ReDim Preserve ROIData(-1 To UBound(ROIData)+1)
   CFNIndex = UBound(CFNList)
   CFN = LCase$(Exe.Path$ + "main_images\" + PathName$(Name, fName)+ ".bmp")
   CFNList(CFNIndex) = CFN
   ROIData(CFNIndex).nLeft = 0
   ROIData(CFNIndex).nTop = 0
   ROIData(CFNIndex).nRight = 400
   ROIData(CFNIndex).nBottom = 200
   ROI = ROIData(CFNIndex)
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   'David Gwillim July 2005
   Local fString As AsciiZ*%Max_Path, Count As Long
   fString=Space$(%Max_Path)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                        ' put Count chars into result string
End Function
